<!doctype html>
<html>
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <style>
    button, input, audio {
      display: block;
      margin-bottom: 10px;
    }
    audio {
      display: none;
    }
  </style>
  <script>
    function $() {
      return document.getElementById(...arguments)
    }

    function onChange(volume) {
      $('audio').volume = parseInt(volume, 10) / 10;
    }

    function onLoad() {
      const audio = $('audio');

      const log = msg => div.innerHTML += msg + "<br>";
      audio.volume = 0.5;
      let audioDevices = [];
      navigator.mediaDevices.getUserMedia({audio: true, video: false}).then(() => {
        navigator.mediaDevices.enumerateDevices().then((devices) => {
          audioDevices = devices.filter(device => device.kind === 'audiooutput');
          log("Found " + audioDevices.length + " audio output devices");
      
          audioDevices.forEach((device) => {
            console.log("Device: " + device.label + " id = " + device.deviceId);
      
            const button = document.createElement('button');
            button.id = device.deviceId;
            button.innerText = device.label;
            button.type = "button";
            button.onclick = () => {
              audio.pause()
              audio.setSinkId(device.deviceId)
                .then( () => {
                  log("Audio is being played from: " + device.label);
                  audio.play();
                })
                .catch( (error) => {
                  log("Audio promise rejected: " + error);
                });
            }
            document.getElementById('buttons').appendChild(button);
          });
        });
      });
    }
      
  </script>
</head>
<body onload="onLoad()">
  <a href="index2.html">Filtered Audio Devices ></a>
  <audio id="audio" src="ring.mp3" controls loop></audio>
  <input type="range" min="1" max="10" value="5" id="volume" onchange="onChange(this.value)">
  <p id="buttons"></p>
  <div id="div"/>
</body>
</html>
